Erstellt oder aktualisiert eine BackupVault-Ressource, die zu einer Ressourcengruppe gehört.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataProtection/backupVaults/{vaultName}?api-version=2026-03-01
URI-Parameter
| Name |
In |
Erforderlich |
Typ |
Beschreibung |
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
Der Name der Ressourcengruppe. Bei dem Namen wird die Groß-/Kleinschreibung nicht beachtet.
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
Hierbei handelt es sich um die ID des Zielabonnements. Der Wert muss eine UUID sein.
|
|
vaultName
|
path |
True
|
string
|
Der Name der BackupVaultResource
|
|
api-version
|
query |
True
|
string
minLength: 1
|
Die API-Version, die für diesen Vorgang verwendet werden soll.
|
| Name |
Erforderlich |
Typ |
Beschreibung |
|
x-ms-authorization-auxiliary
|
|
string
|
|
|
x-ms-deleted-vault-id
|
|
string
|
Die ID des gelöschten Sicherungstresors, aus dem während des Wiederherstellungsvorgangs wiederhergestellt werden soll.
|
Anforderungstext
| Name |
Erforderlich |
Typ |
Beschreibung |
|
location
|
True
|
string
|
Der geografische Standort, an dem sich die Ressource befindet
|
|
properties
|
True
|
BackupVault
|
BackupVaultResource-Eigenschaften
|
|
eTag
|
|
string
|
Optionales ETag.
|
|
identity
|
|
DppIdentityDetails
|
Details zur verwalteten Identität eingeben
|
|
tags
|
|
object
|
Ressourcentags.
|
Antworten
| Name |
Typ |
Beschreibung |
|
200 OK
|
BackupVaultResource
|
Der Aktualisierungsvorgang "BackupVaultResource" der Ressource war erfolgreich
|
|
201 Created
|
BackupVaultResource
|
Der Erstellungsvorgang der Ressource 'BackupVaultResource' war erfolgreich
Header
- Location: string
- Retry-After: integer
|
|
Other Status Codes
|
CloudError
|
Unerwartete Fehlerantwort.
|
Sicherheit
azure_auth
Azure Active Directory OAuth2 Flow.
Typ:
oauth2
Ablauf:
implicit
Autorisierungs-URL:
https://login.microsoftonline.com/common/oauth2/authorize
Bereiche
| Name |
Beschreibung |
|
user_impersonation
|
Identitätswechsel ihres Benutzerkontos
|
Beispiele
Create BackupVault
Beispielanforderung
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
*/
/**
* Sample code: Create BackupVault.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void createBackupVault(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings().withSoftDeleteSettings(new SoftDeleteSettings()
.withState(SoftDeleteState.fromString("Enabled")).withRetentionDurationInDays(14.0D)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings().withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {"crossRegionRestoreSettings": {"state": "Enabled"}},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"}},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVault.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVault() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
FeatureSettings: &armdataprotection.FeatureSettings{
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelAdequate),
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVault.json
*/
async function createBackupVault() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
featureSettings: { crossRegionRestoreSettings: { state: "Enabled" } },
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: { softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" } },
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create BackupVault With CMK
Beispielanforderung
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourceGroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned"
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
},
"softDeleteSettings": {
"retentionDurationInDays": 0,
"state": "Off"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CmkKekIdentity;
import com.azure.resourcemanager.dataprotection.models.CmkKeyVaultProperties;
import com.azure.resourcemanager.dataprotection.models.EncryptionSettings;
import com.azure.resourcemanager.dataprotection.models.EncryptionState;
import com.azure.resourcemanager.dataprotection.models.IdentityType;
import com.azure.resourcemanager.dataprotection.models.ImmutabilitySettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilityState;
import com.azure.resourcemanager.dataprotection.models.InfrastructureEncryptionState;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
*/
/**
* Sample code: Create BackupVault With CMK.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
createBackupVaultWithCMK(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings()
.withSoftDeleteSettings(
new SoftDeleteSettings().withState(SoftDeleteState.OFF).withRetentionDurationInDays(0.0D))
.withImmutabilitySettings(new ImmutabilitySettings().withState(ImmutabilityState.DISABLED))
.withEncryptionSettings(new EncryptionSettings().withState(EncryptionState.ENABLED)
.withKeyVaultProperties(new CmkKeyVaultProperties().withKeyUri("fakeTokenPlaceholder"))
.withKekIdentity(
new CmkKekIdentity().withIdentityType(IdentityType.USER_ASSIGNED).withIdentityId(
"/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"))
.withInfrastructureEncryption(InfrastructureEncryptionState.ENABLED)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_cmk.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned",
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled",
},
"immutabilitySettings": {"state": "Disabled"},
"softDeleteSettings": {"retentionDurationInDays": 0, "state": "Off"},
},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVaultWithCmk() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
EncryptionSettings: &armdataprotection.EncryptionSettings{
InfrastructureEncryption: to.Ptr(armdataprotection.InfrastructureEncryptionStateEnabled),
KekIdentity: &armdataprotection.CmkKekIdentity{
IdentityID: to.Ptr("/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"),
IdentityType: to.Ptr(armdataprotection.IdentityTypeUserAssigned),
},
KeyVaultProperties: &armdataprotection.CmkKeyVaultProperties{
KeyURI: to.Ptr("https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"),
},
State: to.Ptr(armdataprotection.EncryptionStateEnabled),
},
ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
},
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](0),
State: to.Ptr(armdataprotection.SoftDeleteStateOff),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithCMK.json
*/
async function createBackupVaultWithCMK() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: {
encryptionSettings: {
infrastructureEncryption: "Enabled",
kekIdentity: {
identityId:
"/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
identityType: "UserAssigned",
},
keyVaultProperties: {
keyUri: "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3",
},
state: "Enabled",
},
immutabilitySettings: { state: "Disabled" },
softDeleteSettings: { retentionDurationInDays: 0, state: "Off" },
},
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2023-04-01-privatepreview
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"securitySettings": {
"encryptionSettings": {
"infrastructureEncryption": "Enabled",
"kekIdentity": {
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourceGroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi",
"identityType": "UserAssigned"
},
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
},
"softDeleteSettings": {
"retentionDurationInDays": 0,
"state": "Off"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create BackupVault With MSI
Beispielanforderung
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
*/
/**
* Sample code: Create BackupVault With MSI.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
createBackupVaultWithMSI(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings().withSoftDeleteSettings(new SoftDeleteSettings()
.withState(SoftDeleteState.fromString("Enabled")).withRetentionDurationInDays(14.0D)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings().withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder")).create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_msi.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {"crossRegionRestoreSettings": {"state": "Enabled"}},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"}},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_createBackupVaultWithMsi() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("0b352192-dcac-4cc7-992e-a96190ccc68c", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
FeatureSettings: &armdataprotection.FeatureSettings{
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/Backupvaults"),
// ID: to.Ptr("/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample"),
// Location: to.Ptr("WestUS"),
// Properties: &armdataprotection.BackupVault{
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelAdequate),
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// },
// },
// },
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/VaultCRUD/PutBackupVaultWithMSI.json
*/
async function createBackupVaultWithMSI() {
const credential = new DefaultAzureCredential();
const subscriptionId = "0b352192-dcac-4cc7-992e-a96190ccc68c";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate("SampleResourceGroup", "swaggerExample", {
location: "WestUS",
properties: {
featureSettings: { crossRegionRestoreSettings: { state: "Enabled" } },
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: { softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" } },
storageSettings: [{ type: "LocallyRedundant", datastoreType: "VaultStore" }],
},
tags: { key1: "val1" },
});
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
Retry-After: 10
{
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Provisioning",
"secureScore": "Adequate",
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
}
},
"storageSettings": [
{
"type": "LocallyRedundant",
"datastoreType": "VaultStore"
}
]
},
"tags": {
"key1": "val1"
}
}
Create or Update Backup Vault With CMK and Resource Guard Enabled
Beispielanforderung
PUT https://management.azure.com/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"identity": {
"type": "None"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"state": "Off",
"retentionDurationInDays": 0
},
"immutabilitySettings": {
"state": "Disabled"
},
"encryptionSettings": {
"state": "Enabled",
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"kekIdentity": {
"identityType": "UserAssigned",
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"
},
"infrastructureEncryption": "Enabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
Beispiel für eine Antwort
Retry-After: 10
Azure-AsyncOperation: https://management.azure.com/subscriptions/04cf684a-d41f-4550-9f70-7708a3a2283b/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample/operationStatus/YWUzNDFkMzQtZmM5OS00MmUyLWEzNDMtZGJkMDIxZjlmZjgzOzdmYzBiMzhmLTc2NmItNDM5NS05OWQ1LTVmOGEzNzg4MWQzNA==?api-version=2026-03-01
{
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"location": "WestUS",
"tags": {
"key1": "val1"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"state": "Off",
"retentionDurationInDays": 0
},
"immutabilitySettings": {
"state": "Disabled"
},
"encryptionSettings": {
"state": "Enabled",
"keyVaultProperties": {
"keyUri": "https://cmk2xkv.vault.azure.net/keys/Key1/0767b348bb1a4c07baa6c4ec0055d2b3"
},
"kekIdentity": {
"identityType": "UserAssigned",
"identityId": "/subscriptions/85bf5e8c-3084-4f42-add2-746ebb7e97b2/resourcegroups/defaultrg/providers/Microsoft.ManagedIdentity/userAssignedIdentities/examplemsi"
},
"infrastructureEncryption": "Enabled"
}
},
"resourceGuardOperationRequests": [
"/subscriptions/754ec39f-8d2a-44cf-bfbf-13107ac85c36/resourcegroups/mua-testing/providers/Microsoft.DataProtection/resourceGuards/gvjreddy-test-ecy-rg-reader/dppModifyEncryptionSettingsRequests/default"
],
"provisioningState": "Provisioning",
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
{
"identity": {
"type": "None"
},
"id": "/subscriptions/0b352192-dcac-4cc7-992e-a96190ccc68c/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/Backupvaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/Backupvaults",
"location": "WestUS",
"tags": {
"key1": "val1"
},
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"provisioningState": "Succeeded",
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
]
}
}
Restore a soft-deleted backup vault
Beispielanforderung
PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/backupVaults/swaggerExample?api-version=2026-03-01
{
"location": "WestUS",
"properties": {
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
}
},
"tags": {
"key1": "val1"
}
}
import com.azure.resourcemanager.dataprotection.models.AlertsState;
import com.azure.resourcemanager.dataprotection.models.AzureMonitorAlertSettings;
import com.azure.resourcemanager.dataprotection.models.BackupVault;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossRegionRestoreState;
import com.azure.resourcemanager.dataprotection.models.CrossSubscriptionRestoreSettings;
import com.azure.resourcemanager.dataprotection.models.CrossSubscriptionRestoreState;
import com.azure.resourcemanager.dataprotection.models.FeatureSettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilitySettings;
import com.azure.resourcemanager.dataprotection.models.ImmutabilityState;
import com.azure.resourcemanager.dataprotection.models.MonitoringSettings;
import com.azure.resourcemanager.dataprotection.models.SecuritySettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteSettings;
import com.azure.resourcemanager.dataprotection.models.SoftDeleteState;
import com.azure.resourcemanager.dataprotection.models.StorageSetting;
import com.azure.resourcemanager.dataprotection.models.StorageSettingStoreTypes;
import com.azure.resourcemanager.dataprotection.models.StorageSettingTypes;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
/**
* Samples for BackupVaults CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
*/
/**
* Sample code: Restore a soft-deleted backup vault.
*
* @param manager Entry point to DataProtectionManager.
*/
public static void
restoreASoftDeletedBackupVault(com.azure.resourcemanager.dataprotection.DataProtectionManager manager) {
manager.backupVaults().define("swaggerExample").withRegion("WestUS")
.withExistingResourceGroup("SampleResourceGroup")
.withProperties(new BackupVault()
.withMonitoringSettings(new MonitoringSettings().withAzureMonitorAlertSettings(
new AzureMonitorAlertSettings().withAlertsForAllJobFailures(AlertsState.ENABLED)))
.withSecuritySettings(new SecuritySettings()
.withSoftDeleteSettings(new SoftDeleteSettings().withState(SoftDeleteState.fromString("Enabled"))
.withRetentionDurationInDays(14.0D))
.withImmutabilitySettings(new ImmutabilitySettings().withState(ImmutabilityState.DISABLED)))
.withStorageSettings(
Arrays.asList(new StorageSetting().withDatastoreType(StorageSettingStoreTypes.VAULT_STORE)
.withType(StorageSettingTypes.LOCALLY_REDUNDANT)))
.withFeatureSettings(new FeatureSettings()
.withCrossSubscriptionRestoreSettings(
new CrossSubscriptionRestoreSettings().withState(CrossSubscriptionRestoreState.DISABLED))
.withCrossRegionRestoreSettings(
new CrossRegionRestoreSettings().withState(CrossRegionRestoreState.ENABLED))))
.withTags(mapOf("key1", "fakeTokenPlaceholder"))
.withXMsDeletedVaultId(
"/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample")
.create();
}
// Use "Map.of" if available
@SuppressWarnings("unchecked")
private static <T> Map<String, T> mapOf(Object... inputs) {
Map<String, T> map = new HashMap<>();
for (int i = 0; i < inputs.length; i += 2) {
String key = (String) inputs[i];
T value = (T) inputs[i + 1];
map.put(key, value);
}
return map;
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.dataprotection import DataProtectionMgmtClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-dataprotection
# USAGE
python put_backup_vault_with_undelete.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = DataProtectionMgmtClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.backup_vaults.begin_create_or_update(
resource_group_name="SampleResourceGroup",
vault_name="swaggerExample",
parameters={
"location": "WestUS",
"properties": {
"featureSettings": {
"crossRegionRestoreSettings": {"state": "Enabled"},
"crossSubscriptionRestoreSettings": {"state": "Disabled"},
},
"monitoringSettings": {"azureMonitorAlertSettings": {"alertsForAllJobFailures": "Enabled"}},
"securitySettings": {
"immutabilitySettings": {"state": "Disabled"},
"softDeleteSettings": {"retentionDurationInDays": 14, "state": "Enabled"},
},
"storageSettings": [{"datastoreType": "VaultStore", "type": "LocallyRedundant"}],
},
"tags": {"key1": "val1"},
},
).result()
print(response)
# x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
package armdataprotection_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v4"
)
// Generated from example definition: 2026-03-01/PutBackupVaultWithUndelete.json
func ExampleBackupVaultsClient_BeginCreateOrUpdate_restoreASoftDeletedBackupVault() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armdataprotection.NewClientFactory("00000000-0000-0000-0000-000000000000", cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
poller, err := clientFactory.NewBackupVaultsClient().BeginCreateOrUpdate(ctx, "SampleResourceGroup", "swaggerExample", armdataprotection.BackupVaultResource{
Location: to.Ptr("WestUS"),
Properties: &armdataprotection.BackupVault{
MonitoringSettings: &armdataprotection.MonitoringSettings{
AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
},
},
SecuritySettings: &armdataprotection.SecuritySettings{
SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
RetentionDurationInDays: to.Ptr[float64](14),
State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
},
ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
},
},
StorageSettings: []*armdataprotection.StorageSetting{
{
DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
},
},
FeatureSettings: &armdataprotection.FeatureSettings{
CrossSubscriptionRestoreSettings: &armdataprotection.CrossSubscriptionRestoreSettings{
State: to.Ptr(armdataprotection.CrossSubscriptionRestoreStateDisabled),
},
CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
},
},
},
Tags: map[string]*string{
"key1": to.Ptr("val1"),
},
}, &armdataprotection.BackupVaultsClientBeginCreateOrUpdateOptions{
XMSDeletedVaultID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample")})
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
res, err := poller.PollUntilDone(ctx, nil)
if err != nil {
log.Fatalf("failed to pull the result: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armdataprotection.BackupVaultsClientCreateOrUpdateResponse{
// BackupVaultResource: &armdataprotection.BackupVaultResource{
// Location: to.Ptr("WestUS"),
// Tags: map[string]*string{
// "key1": to.Ptr("val1"),
// },
// ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample"),
// Name: to.Ptr("swaggerExample"),
// Type: to.Ptr("Microsoft.DataProtection/BackupVaults"),
// Properties: &armdataprotection.BackupVault{
// ProvisioningState: to.Ptr(armdataprotection.ProvisioningStateSucceeded),
// ResourceMoveState: to.Ptr(armdataprotection.ResourceMoveStateUnknown),
// MonitoringSettings: &armdataprotection.MonitoringSettings{
// AzureMonitorAlertSettings: &armdataprotection.AzureMonitorAlertSettings{
// AlertsForAllJobFailures: to.Ptr(armdataprotection.AlertsStateEnabled),
// },
// },
// SecuritySettings: &armdataprotection.SecuritySettings{
// SoftDeleteSettings: &armdataprotection.SoftDeleteSettings{
// RetentionDurationInDays: to.Ptr[float64](14),
// State: to.Ptr(armdataprotection.SoftDeleteState("Enabled")),
// },
// ImmutabilitySettings: &armdataprotection.ImmutabilitySettings{
// State: to.Ptr(armdataprotection.ImmutabilityStateDisabled),
// },
// },
// StorageSettings: []*armdataprotection.StorageSetting{
// {
// DatastoreType: to.Ptr(armdataprotection.StorageSettingStoreTypesVaultStore),
// Type: to.Ptr(armdataprotection.StorageSettingTypesLocallyRedundant),
// },
// },
// FeatureSettings: &armdataprotection.FeatureSettings{
// CrossSubscriptionRestoreSettings: &armdataprotection.CrossSubscriptionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossSubscriptionRestoreStateDisabled),
// },
// CrossRegionRestoreSettings: &armdataprotection.CrossRegionRestoreSettings{
// State: to.Ptr(armdataprotection.CrossRegionRestoreStateEnabled),
// },
// },
// SecureScore: to.Ptr(armdataprotection.SecureScoreLevelMaximum),
// IsVaultProtectedByResourceGuard: to.Ptr(false),
// ResourceGuardOperationRequests: []*string{
// },
// ReplicatedRegions: []*string{
// },
// },
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { DataProtectionClient } = require("@azure/arm-dataprotection");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a BackupVault resource belonging to a resource group.
*
* @summary creates or updates a BackupVault resource belonging to a resource group.
* x-ms-original-file: 2026-03-01/PutBackupVaultWithUndelete.json
*/
async function restoreASoftDeletedBackupVault() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-0000-0000-0000-000000000000";
const client = new DataProtectionClient(credential, subscriptionId);
const result = await client.backupVaults.createOrUpdate(
"SampleResourceGroup",
"swaggerExample",
{
location: "WestUS",
properties: {
monitoringSettings: { azureMonitorAlertSettings: { alertsForAllJobFailures: "Enabled" } },
securitySettings: {
softDeleteSettings: { retentionDurationInDays: 14, state: "Enabled" },
immutabilitySettings: { state: "Disabled" },
},
storageSettings: [{ datastoreType: "VaultStore", type: "LocallyRedundant" }],
featureSettings: {
crossSubscriptionRestoreSettings: { state: "Disabled" },
crossRegionRestoreSettings: { state: "Enabled" },
},
},
tags: { key1: "val1" },
},
{
xMsDeletedVaultId:
"/subscriptions/00000000-0000-0000-0000-000000000000/providers/Microsoft.DataProtection/locations/WestUS/deletedVaults/swaggerExample",
},
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Beispiel für eine Antwort
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/BackupVaults",
"properties": {
"provisioningState": "Succeeded",
"resourceMoveState": "Unknown",
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"secureScore": "Maximum",
"isVaultProtectedByResourceGuard": false,
"resourceGuardOperationRequests": [],
"replicatedRegions": []
}
}
{
"location": "WestUS",
"tags": {
"key1": "val1"
},
"id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/SampleResourceGroup/providers/Microsoft.DataProtection/BackupVaults/swaggerExample",
"name": "swaggerExample",
"type": "Microsoft.DataProtection/BackupVaults",
"properties": {
"provisioningState": "Succeeded",
"resourceMoveState": "Unknown",
"monitoringSettings": {
"azureMonitorAlertSettings": {
"alertsForAllJobFailures": "Enabled"
}
},
"securitySettings": {
"softDeleteSettings": {
"retentionDurationInDays": 14,
"state": "Enabled"
},
"immutabilitySettings": {
"state": "Disabled"
}
},
"storageSettings": [
{
"datastoreType": "VaultStore",
"type": "LocallyRedundant"
}
],
"featureSettings": {
"crossSubscriptionRestoreSettings": {
"state": "Disabled"
},
"crossRegionRestoreSettings": {
"state": "Enabled"
}
},
"secureScore": "Maximum",
"isVaultProtectedByResourceGuard": false,
"resourceGuardOperationRequests": [],
"replicatedRegions": []
}
}
Definitionen
AlertsState
Enumeration
| Wert |
Beschreibung |
|
Enabled
|
|
|
Disabled
|
|
AzureMonitorAlertSettings
Objekt
Einstellungen für azure Monitor-basierte Warnungen
| Name |
Typ |
Beschreibung |
|
alertsForAllJobFailures
|
AlertsState
|
|
BackupVault
Objekt
Datensicherungstresor
| Name |
Typ |
Beschreibung |
|
bcdrSecurityLevel
|
BCDRSecurityLevel
|
Sicherheitsstufe des Sicherungstresors
|
|
featureSettings
|
FeatureSettings
|
Featureeinstellungen
|
|
isVaultProtectedByResourceGuard
|
boolean
|
Ist tresorgeschützt durch Resource Guard
|
|
monitoringSettings
|
MonitoringSettings
|
Überwachungseinstellungen
|
|
provisioningState
|
ProvisioningState
|
Bereitstellungsstatus der BackupVault-Ressource
|
|
replicatedRegions
|
string[]
|
Liste der replizierten Regionen für den Sicherungstresor
|
|
resourceGuardOperationRequests
|
string[]
|
ResourceGuardOperationRequests, für die LAC-Überprüfung ausgeführt wird
|
|
resourceMoveDetails
|
ResourceMoveDetails
|
Ressourcenverschiebungsdetails für den Sicherungstresor
|
|
resourceMoveState
|
ResourceMoveState
|
Ressourcenverschiebungsstatus für den Sicherungstresor
|
|
secureScore
|
SecureScoreLevel
|
Sicherheitsbewertung des Sicherungstresors
|
|
securitySettings
|
SecuritySettings
|
Sicherheitseinstellungen
|
|
storageSettings
|
StorageSetting[]
|
Speichereinstellungen
|
BackupVaultResource
Objekt
Backup Vault-Ressource
| Name |
Typ |
Beschreibung |
|
eTag
|
string
|
Optionales ETag.
|
|
id
|
string
(arm-id)
|
Vollqualifizierte Ressourcen-ID für die Ressource. Z. B. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
|
|
identity
|
DppIdentityDetails
|
Details zur verwalteten Identität eingeben
|
|
location
|
string
|
Der geografische Standort, an dem sich die Ressource befindet
|
|
name
|
string
|
Der Name der Ressource
|
|
properties
|
BackupVault
|
BackupVaultResource-Eigenschaften
|
|
systemData
|
systemData
|
Azure Resource Manager-Metadaten, die createdBy- und modifiedBy-Informationen enthalten.
|
|
tags
|
object
|
Ressourcentags.
|
|
type
|
string
|
Der Typ der Ressource. Z. B. "Microsoft.Compute/virtualMachines" oder "Microsoft.Storage/storageAccounts"
|
BCDRSecurityLevel
Enumeration
Sicherheitsstufe des Sicherungstresors
| Wert |
Beschreibung |
|
Poor
|
|
|
Fair
|
|
|
Good
|
|
|
Excellent
|
|
|
NotSupported
|
|
CloudError
Objekt
Eine Fehlerantwort von Azure Backup.
| Name |
Typ |
Beschreibung |
|
error
|
Error
|
Die Fehlerantwort für die Ressourcenverwaltung.
|
CmkKekIdentity
Objekt
Die Details der verwalteten Identität, die für CMK verwendet wird
| Name |
Typ |
Beschreibung |
|
identityId
|
string
|
Die verwaltete Identität, die verwendet werden soll, die Zugriffsberechtigungen für den Key Vault hat. Geben Sie hier einen Wert für den Fall von Identitätstypen an: nur 'UserAssigned'.
|
|
identityType
|
IdentityType
|
Der Identitätstyp. "SystemAssigned" und "UserAssigned" schließen sich gegenseitig aus. "SystemAssigned" verwendet implizit erstellte verwaltete Identität.
|
CmkKeyVaultProperties
Objekt
Die Eigenschaften des Key Vault, der CMK hosten
| Name |
Typ |
Beschreibung |
|
keyUri
|
string
|
Der Schlüssel-URI des vom Kunden verwalteten Schlüssels
|
createdByType
Enumeration
Der Identitätstyp, der die Ressource erstellt hat.
| Wert |
Beschreibung |
|
User
|
|
|
Application
|
|
|
ManagedIdentity
|
|
|
Key
|
|
CrossRegionRestoreSettings
Objekt
CrossRegionRestoreState
Enumeration
CrossRegionRestore-Status
| Wert |
Beschreibung |
|
Disabled
|
|
|
Enabled
|
|
CrossSubscriptionRestoreSettings
Objekt
CrossSubscriptionRestore-Einstellungen
CrossSubscriptionRestoreState
Enumeration
CrossSubscriptionRestore-Status
| Wert |
Beschreibung |
|
Disabled
|
|
|
PermanentlyDisabled
|
|
|
Enabled
|
|
DppIdentityDetails
Objekt
Identitätsdetails
| Name |
Typ |
Beschreibung |
|
principalId
|
string
|
Die Objekt-ID des Dienstprinzipalobjekts für die verwaltete Identität, die verwendet wird, um rollenbasierten Zugriff auf eine Azure-Ressource zu gewähren.
|
|
tenantId
|
string
|
Eine GUID (Globally Unique Identifier), die den Azure AD-Mandanten darstellt, in dem die Ressource jetzt Mitglied ist.
|
|
type
|
string
|
Der IdentityType, der entweder SystemAssigned, UserAssigned, "SystemAssigned,UserAssigned" oder "None" sein kann
|
|
userAssignedIdentities
|
<string,
UserAssignedIdentity>
|
Dient zum Abrufen oder Festlegen der vom Benutzer zugewiesenen Identitäten.
|
encryptionSettings
Objekt
Vom Kunden verwaltete Schlüsseldetails der Ressource.
EncryptionState
Enumeration
Verschlüsselungsstatus des Sicherungstresors.
| Wert |
Beschreibung |
|
Enabled
|
CMK-Verschlüsselung ist im Sicherungstresor aktiviert
|
|
Disabled
|
CMK-Verschlüsselung ist im Sicherungstresor deaktiviert. Der Benutzer kann diesen Zustand nicht festlegen, sobald der Verschlüsselungsstatus "Aktiviert" ist.
|
|
Inconsistent
|
CMK-Verschlüsselung befindet sich im Sicherungstresor inkonsistent. Dieser Zustand gibt an, dass der Benutzer den Verschlüsselungseinstellungenvorgang sofort wiederholen muss, um den Zustand zu korrigieren.
|
Error
Objekt
Die Fehlerantwort für die Ressourcenverwaltung.
| Name |
Typ |
Beschreibung |
|
additionalInfo
|
ErrorAdditionalInfo[]
|
Die zusätzlichen Informationen des Fehlers.
|
|
code
|
string
|
Der Fehlercode.
|
|
details
|
Error[]
|
Die Fehlerdetails.
|
|
message
|
string
|
Die Fehlermeldung.
|
|
target
|
string
|
Das Fehlerziel.
|
ErrorAdditionalInfo
Objekt
Der Ressourcenverwaltungsfehler zusätzliche Informationen.
| Name |
Typ |
Beschreibung |
|
info
|
object
|
Die zusätzlichen Informationen.
|
|
type
|
string
|
Der zusätzliche Informationstyp.
|
FeatureSettings
Objekt
Klasse mit Featureeinstellungen des Tresors
IdentityType
Enumeration
Der Identitätstyp. "SystemAssigned" und "UserAssigned" schließen sich gegenseitig aus. "SystemAssigned" verwendet implizit erstellte verwaltete Identität.
| Wert |
Beschreibung |
|
SystemAssigned
|
|
|
UserAssigned
|
|
ImmutabilitySettings
Objekt
Unveränderlichkeitseinstellungen auf Tresorebene
ImmutabilityState
Enumeration
Unveränderlichkeitszustand
| Wert |
Beschreibung |
|
Disabled
|
|
|
Unlocked
|
|
|
Locked
|
|
InfrastructureEncryptionState
Enumeration
Aktivieren/Deaktivieren des Doppeltverschlüsselungszustands
| Wert |
Beschreibung |
|
Enabled
|
|
|
Disabled
|
|
MonitoringSettings
Objekt
Überwachungseinstellungen
ProvisioningState
Enumeration
Bereitstellungsstatus der BackupVault-Ressource
| Wert |
Beschreibung |
|
Failed
|
|
|
Provisioning
|
|
|
Succeeded
|
|
|
Unknown
|
|
|
Updating
|
|
ResourceMoveDetails
Objekt
ResourceMoveDetails wird als Reaktion auf den GetResource-Aufruf von ARM zurückgegeben.
| Name |
Typ |
Beschreibung |
|
completionTimeUtc
|
string
|
Abschlusszeit in UTC des neuesten ResourceMove-Vorgangs versucht. ISO 8601-Format.
|
|
operationId
|
string
|
CorrelationId des letzten Versuchten ResourceMove-Vorgangs
|
|
sourceResourcePath
|
string
|
ARM-Ressourcenpfad der Quellressource
|
|
startTimeUtc
|
string
|
Startzeit in UTC der neuesten ResourceMove-Operation versucht. ISO 8601-Format.
|
|
targetResourcePath
|
string
|
ARM-Ressourcenpfad der Zielressource, die in der neuesten ResourceMove-Operation verwendet wird
|
ResourceMoveState
Enumeration
Ressourcenverschiebungsstatus für den Sicherungstresor
| Wert |
Beschreibung |
|
Unknown
|
|
|
InProgress
|
|
|
PrepareFailed
|
|
|
CommitFailed
|
|
|
Failed
|
|
|
PrepareTimedout
|
|
|
CommitTimedout
|
|
|
CriticalFailure
|
|
|
PartialSuccess
|
|
|
MoveSucceeded
|
|
SecureScoreLevel
Enumeration
Sicherheitsbewertung des Sicherungstresors
| Wert |
Beschreibung |
|
None
|
|
|
Minimum
|
|
|
Adequate
|
|
|
Maximum
|
|
|
NotSupported
|
|
SecuritySettings
Objekt
Klasse mit Sicherheitseinstellungen des Tresors
| Name |
Typ |
Beschreibung |
|
encryptionSettings
|
encryptionSettings
|
Vom Kunden verwaltete Schlüsseldetails der Ressource.
|
|
immutabilitySettings
|
ImmutabilitySettings
|
Unveränderlichkeitseinstellungen auf Tresorebene
|
|
softDeleteSettings
|
SoftDeleteSettings
|
Einstellungen für vorläufiges Löschen
|
SoftDeleteSettings
Objekt
Einstellungen für vorläufiges Löschen
| Name |
Typ |
Beschreibung |
|
retentionDurationInDays
|
number
(double)
|
Aufbewahrungsdauer für vorläufiges Löschen
|
|
state
|
SoftDeleteState
|
Status des vorläufigen Löschens
|
SoftDeleteState
Enumeration
Status des vorläufigen Löschens
| Wert |
Beschreibung |
|
Off
|
"Vorläufiges Löschen" ist für "BackupVault" deaktiviert.
|
|
On
|
"Vorläufiges Löschen" ist für "BackupVault" aktiviert, kann aber deaktiviert werden.
|
|
AlwaysOn
|
"Vorläufiges Löschen" ist für "BackupVault" dauerhaft aktiviert, und die Einstellung kann nicht geändert werden.
|
StorageSetting
Objekt
Speichereinstellung
StorageSettingStoreTypes
Enumeration
Dient zum Abrufen oder Festlegen des Typs des Datenspeichers.
| Wert |
Beschreibung |
|
ArchiveStore
|
|
|
OperationalStore
|
|
|
VaultStore
|
|
StorageSettingTypes
Enumeration
Dient zum Abrufen oder Festlegen des Typs.
| Wert |
Beschreibung |
|
GeoRedundant
|
|
|
LocallyRedundant
|
|
|
ZoneRedundant
|
|
systemData
Objekt
Metadaten zur Erstellung und letzten Änderung der Ressource.
| Name |
Typ |
Beschreibung |
|
createdAt
|
string
(date-time)
|
Der Zeitstempel der Ressourcenerstellung (UTC).
|
|
createdBy
|
string
|
Die Identität, die die Ressource erstellt hat.
|
|
createdByType
|
createdByType
|
Der Identitätstyp, der die Ressource erstellt hat.
|
|
lastModifiedAt
|
string
(date-time)
|
Der Zeitstempel der letzten Änderung der Ressource (UTC)
|
|
lastModifiedBy
|
string
|
Die Identität, die die Ressource zuletzt geändert hat.
|
|
lastModifiedByType
|
createdByType
|
Der Identitätstyp, der die Ressource zuletzt geändert hat.
|
UserAssignedIdentity
Objekt
Benutzer zugewiesene Identitätseigenschaften
| Name |
Typ |
Beschreibung |
|
clientId
|
string
(uuid)
|
Die Client-ID der zugewiesenen Identität.
|
|
principalId
|
string
(uuid)
|
Die Prinzipal-ID der zugewiesenen Identität.
|